(* format:
 *   name arg, "arg", arg ...
 *   # comment
 *)

unit SConfFile;

interface

type
  TSConfFile = class(TObject)
  private
    FBuffer: string;
    FBufferPos: Integer;
    FResultCode: Integer;
    function GetName(var pBuf: PChar): PChar;
    function GetArg(var pBuf: PChar): PChar;
  public
    constructor Create(const FileName: string);
    function GetLine(var Name: string; var ArgCount: Integer; var Args: array of string): Boolean;
  end;

implementation

{ TSConfFile }

constructor TSConfFile.Create(const FileName: string);
var
  F: Text;
  TextBuf: array[0..4095] of Char;
  s: string;
begin
  FileMode := 0; // read only mode
  AssignFile(F, FileName);
  {$I-}
  Reset(F);
  {$I+}
  FResultCode := IOResult;
  if FResultCode <> 0 then
    Exit;
  SetTextBuf(F, TextBuf);
  // Rg(s#)Ƌs폜As̋؂#0ɂ
  // FBufferɏ
  while not Eof(F) do
  begin
    Readln(F, s);
    if (s = '') or (s[1] = '#') then
      Continue;
    FBuffer := FBuffer + s + #0;
  end;
  CloseFile(F);
end;

function TSConfFile.GetName(var pBuf: PChar): PChar;
begin
  while pBuf^ in [#9, ' '] do
    Inc(pBuf);
  Result := pBuf;
  while not (pBuf^ in [#0, #9, ' ']) do
    Inc(pBuf);
  if pBuf^ <> #0 then
  begin
    pBuf^ := #0;
    Inc(pBuf);
  end;
end;

function TSConfFile.GetArg(var pBuf: PChar): PChar;
begin
  while pBuf^ in [#9, ' '] do
    Inc(pBuf);
  if pBuf^ = '"' then
  begin
    Inc(pBuf);
    Result := pBuf;
    while not (pBuf^ in [#0, '"']) do
      Inc(pBuf);
    if pBuf^ = '"' then
    begin
      pBuf^ := #0;
      Inc(pBuf);
    end;
  end
  else begin
    Result := pBuf;
    while not (pBuf^ in [#0, #9, ' ', ',']) do
      Inc(pBuf);
  end;
  if pBuf^ = ',' then
  begin
    pBuf^ := #0;
    Inc(pBuf);
  end
  else if pBuf^ <> #0 then
  begin
    pBuf^ := #0;
    Inc(pBuf);
    while not (pBuf^ in [#0, ',']) do
      Inc(pBuf);
  end;
end;

function TSConfFile.GetLine(var Name: string; var ArgCount: Integer; var Args: array of string): Boolean;
var
  NextPos: Integer;
  pBuf: PChar;
  i: Integer;
begin
  if (FResultCode <> 0) or (FBufferPos = Length(FBuffer)) then
    Result := False
  else begin
    // parse#0ŏ㏑̂ł̑OɎ̍s̈ʒu
    NextPos := FBufferPos + 1;
    while (FBuffer[NextPos] <> #0) do
      Inc(NextPos);

    pBuf := @FBuffer[FBufferPos+1];
    Name := GetName(pBuf);

    ArgCount := 0;
    for i := 0 to High(Args) do
      Args[i] := '';
    while pBuf^ <> #0 do
    begin
      Args[ArgCount] := GetArg(pBuf);
      Inc(ArgCount);
      if ArgCount > High(Args) then
        Break;
    end;

    FBufferPos := NextPos;

    Result := True;
  end;
end;

end.
