unit Command;

interface

const
    cmPause = 'Pause';
    cmStop = 'Stop';
    cmSkipPrev = 'SkipPrev';
    cmSkipNext = 'SkipNext';
    cmMute = 'Mute';
    cmFullScreen = 'FullScreen';
    cmStayOnTop = 'StayOnTop';
    cmZoom50 = 'Zoom50';
    cmZoom100 = 'Zoom100';
    cmZoom150 = 'Zoom150';
    cmZoom200 = 'Zoom200';
    cmZoom300 = 'Zoom300';
    cmZoom400 = 'Zoom400';
    cmSeekForward = 'SeekForward';
    cmSeekBack = 'SeekBack';
    cmSeekForwardFast = 'SeekForwardFast';
    cmSeekBackFast = 'SeekBackFast';
    cmSeekForwardFaster = 'SeekForwardFaster';
    cmSeekBackFaster = 'SeekBackFaster';
    cmAspect43 = 'Aspect43';
    cmAspect169 = 'Aspect169';
    cmAspectOrg = 'AspectOrg';
    cmAspectAuto = 'AspectAuto';
    cmRepeat = 'Repeat';
    cmScreenCapture = 'ScreenCapture';
    cmAbout = 'About';
    cmExit = 'Exit';

var
  CmdList: array[0..26] of string = (
    cmPause,
    cmStop,
    cmSkipPrev,
    cmSkipNext,
    cmMute,
    cmFullScreen,
    cmStayOnTop,
    cmZoom50,
    cmZoom100,
    cmZoom150,
    cmZoom200,
    cmZoom300,
    cmZoom400,
    cmSeekForward,
    cmSeekBack,
    cmSeekForwardFast,
    cmSeekBackFast,
    cmSeekForwardFaster,
    cmSeekBackFaster,
    cmAspect43,
    cmAspect169,
    cmAspectOrg,
    cmAspectAuto,
    cmRepeat,
    cmScreenCapture,
    cmAbout,
    cmExit
  );

  MenuTable: array[0..30*2-1] of string = (
    '&Play / Pause',              cmPause,
    '&Stop',                      cmStop,
    'Skip &Previous',             cmSkipPrev,
    'Skip &Next',                 cmSkipNext,
    '&Mute',                      cmMute,
    '&Repeat',                    cmRepeat,
    '-',                          '',
    'Zoom &50%',                  cmZoom50,
    'Zoom &100%',                 cmZoom100,
    'Zoom 150%(&Q)',              cmZoom150,
    'Zoom &200%',                 cmZoom200,
    'Zoom &300%',                 cmZoom300,
    'Zoom &400%',                 cmZoom400,
    '-',                          '',
    'Aspect A&uto',               cmAspectAuto,
    'Aspect Ori&ginal',           cmAspectOrg,
    'Aspect 4:3(&E)',             cmAspect43,
    'Aspect 16:9(&W)',            cmAspect169,
    '-',                          '',
    'Full &Screen',               cmFullScreen,
    'Stay &On Top',               cmStayOnTop,
    '-',                          '',
    'Save Screen &Capture As...', cmScreenCapture,
    '-',                          '',
    '&Filter Properties',         '{FilterMenu',
    '',                           '}',
    '-',                          '',
    '&About',                     cmAbout,
    '-',                          '',
    'E&xit',                      cmExit
  );

const
  DefaultKeys: array[0..30*2-1] of string = (
    'Enter',   cmFullScreen,
    'Esc',     cmStop,
    'Space',   cmPause,
    'Left',    cmSeekBack,
    'S-Left',  cmSeekBackFast,
    'Right',   cmSeekForward,
    'S-Right', cmSeekForwardFast,
    'Down',    cmSeekForwardFaster,
    'Up',      cmSeekBackFaster,
    'Num1',    cmZoom100,
    'Num2',    cmZoom200,
    'Num3',    cmZoom300,
    'Num4',    cmZoom400,
    'Num5',    cmZoom50,
    '1',       cmZoom100,
    '2',       cmZoom200,
    '3',       cmZoom300,
    '4',       cmZoom400,
    '5',       cmZoom50,
    'A',       cmAspectAuto,
    'B',       cmSkipPrev,
    'E',       cmAspect43,
    'M',       cmMute,
    'N',       cmSkipNext,
    'O',       cmAspectOrg,
    'P',       cmSkipPrev,
    'Q',       cmZoom150,
    'R',       cmRepeat,
    'T',       cmStayOnTop,
    'W',       cmAspect169
  );

implementation

end.
